/* Author: Ting Hou-Chun                        */
/* 1997/6/19                                    */
/* Bug report: vdo81830@commlab8.ee.nctu.edu.tw */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define GLOBAL /* used by global.h */
#include "config.h"
#include "global.h"

int main(argc, argv)
int argc;
char *argv[];
{
  int dbgv, i, sc, ec, vc; 
  char rawpre[40], bmppre[40], ifn[40], ofn[40];

  if (argc > 3) {
    strcpy(rawpre, argv[1]);
    sprintf(ifn, "%s.Y", rawpre);
    if ((infile[0] = fopen(ifn, "rb")) == NULL) {
      fprintf(stderr,"\nraw2bmp cannot open %s \n", ifn);
      exit(1);
    }
    file_mode = COMP400;
    indien = SMALL;
    headersize = 0;

    image_width = atoi(argv[2]);
    image_height = atoi(argv[3]);

    fseek(infile[0], 0, SEEK_END);
    FrameNumber = ftell(infile[0]) / (image_width * image_height);
    fseek(infile[0], 0, SEEK_SET);

    BitsPerPixel = 8;

  }
  else {
    /* arguments problem */
    print_errmsg();
    exit(0);
  }
  if (argc == 4) {
    print_report();
    exit(0);
  }
  if (argc > 4)
    strcpy(bmppre, argv[4]);

  /* default setting */
  /* start count */
  sc = 0; 
  /* end count */
  ec = 0; 
  /* interval count */
  vc = 1;

  if (argc > 5)
    sc = atoi(argv[5]);
  if (argc > 6)
    ec = atoi(argv[6]);
  if (argc > 7)
    vc = atoi(argv[7]);

  /* debug level */
  dbgv = 1;

  /* start counting from 0 */
  ec = (ec < FrameNumber) ? ec : FrameNumber - 1;
  for (select_frame = sc; select_frame <= ec; select_frame += vc) {

    get_compimage();

    /* duplicate components */

    memcpy(image_map[1], image_map[0], image_width * image_height);
    memcpy(image_map[2], image_map[0], image_width * image_height);

    /* outfile name */
    if (sc == ec)
      sprintf(ofn, "%s.bmp", bmppre);
    else
      sprintf(ofn, "%s%d.bmp", bmppre, select_frame);
    if ((outfile[0] = fopen(ofn, "wb")) == NULL) {
      fprintf(stderr,"\ngetanimage cannot open %s \n", ofn);
      exit(1);
    }

    BitsPerPixel = 24;
    Compression = 0;
    indien = BIG;

    put_bmpimage();
    fclose(outfile[0]);
  }
  fclose(infile[0]);

  return 0;
}

int print_report() {
  printf("RAW header report:\n"); 
  printf("  width      = %5d\n", image_width); 
  printf("  height     = %5d\n", image_height); 
  printf("  frames     = %5d\n", FrameNumber);
  printf("  bits/pixel = %5d\n", BitsPerPixel);
  return(0);
}

int print_errmsg() {
  printf("Usage:\n"); 
  printf("  raw2bmp in(raw) width height [out(bmp)] [start [end [increment]]] \n");
  printf("  (Caution: width and height required.) \n");
  return(0);
}

